---
title: WritableStream
slug: Web/API/WritableStream
tags:
  - API
  - Experimental
  - Interface
  - Reference
  - Streams
  - WritableStream
---
<p>{{SeeCompatTable}}{{APIRef("Streams")}}</p>

<p>The <strong><code>WritableStream</code></strong> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> provides a standard abstraction for writing streaming data to a destination, known as a sink. This object comes with built-in backpressure and queuing.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("WritableStream.WritableStream", "WritableStream()")}}</dt>
 <dd>Creates a new <code>WritableStream</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("WritableStream.locked")}} {{readonlyinline}}</dt>
 <dd>A boolean indicating whether the <code>WritableStream</code> is locked to a writer. </dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("WritableStream.abort()")}}</dt>
 <dd>Aborts the stream, signaling that the producer can no longer successfully write to the stream and it is to be immediately moved to an error state, with any queued writes discarded.</dd>
 <dt>{{domxref("WritableStream.close()")}}</dt>
 <dd>Closes the stream.</dd>
 <dt>{{domxref("WritableStream.getWriter()")}}</dt>
 <dd>Returns a new instance of {{domxref("WritableStreamDefaultWriter")}} and locks the stream to that instance. While the stream is locked, no other writer can be acquired until this one is released. </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example illustrates several features of this interface.  It shows the creation of the <code>WritableStream</code> with a custom sink and an API-supplied queueing strategy. It then calls a function called <code>sendMessage()</code>, passing the newly created stream and a string. Inside this function it calls the stream's <code>getWriter()</code> method, which returns an instance of {{domxref("WritableStreamDefaultWriter")}}. A <code>forEach()</code> call is used to write each chunk of the string to the stream. Finally, <code>write()</code> and <code>close()</code> return promises that are processed to deal with success or failure of chunks and streams.</p>

<ul>
</ul>

<pre class="brush: js">const list = document.querySelector('ul');

function sendMessage(message, writableStream) {
  // defaultWriter is of type WritableStreamDefaultWriter
  const defaultWriter = writableStream.getWriter();
  const encoder = new TextEncoder();
  const encoded = encoder.encode(message, { stream: true });
  encoded.forEach((chunk) =&gt; {
    defaultWriter.ready
      .then(() =&gt; {
        return defaultWriter.write(chunk);
      })
      .then(() =&gt; {
        console.log("Chunk written to sink.");
      })
      .catch((err) =&gt; {
        console.log("Chunk error:", err);
      });
  });
  // Call ready again to ensure that all chunks are written
  //   before closing the writer.
  defaultWriter.ready
    .then(() =&gt; {
      defaultWriter.close();
    })
    .then(() =&gt; {
      console.log("All chunks written");
    })
    .catch((err) =&gt; {
      console.log("Stream error:", err);
    });
}

const decoder = new TextDecoder("utf-8");
const queuingStrategy = new CountQueuingStrategy({ highWaterMark: 1 });
let result = "";
const writableStream = new WritableStream({
  // Implement the sink
  write(chunk) {
    return new Promise((resolve, reject) =&gt; {
      var buffer = new ArrayBuffer(2);
      var view = new Uint16Array(buffer);
      view[0] = chunk;
      var decoded = decoder.decode(view, { stream: true });
      var listItem = document.createElement('li');
      listItem.textContent = "Chunk decoded: " + decoded;
      list.appendChild(listItem);
      result += decoded;
      resolve();
    });
  },
  close() {
    var listItem = document.createElement('li');
    listItem.textContent = "[MESSAGE RECEIVED] " + result;
    list.appendChild(listItem);
  },
  abort(err) {
    console.log("Sink error:", err);
  }
}, queuingStrategy);

sendMessage("Hello, world.", writableStream);</pre>

<p>You can find the full code in our <a href="https://mdn.github.io/dom-examples/streams/simple-writer/">Simple writer example</a>.</p>

<h3 id="Backpressure">Backpressure</h3>

<p>Because of how backpressure is supported in the API, its implementation in code may be less than obvious. To see how backpressure is implemented look for three things.</p>

<ul>
 <li>The <code>highWaterMark</code> property, which is set when creating the counting strategy (line 35), sets the maximum amount of data that the <code>WritableStream</code> instance will handle in a single <code>write()</code> operation. In this example, it's the maximum amount of data that can be sent to <code>defaultWriter.write()</code> (line 11).</li>
 <li>The <code>defaultWriter.ready</code> property returns a promise that resolves when the sink (the first property of the <code>WritableStream</code> constructor) is done writing data. The data source can either write more data (line 9) or call <code>close()</code> (line 24). Calling close() too early can prevent data from being written. This is why the example calls <code>defaultWriter.ready</code> twice (lines 9 and 22). </li>
 <li>The {{jsxref("Promise")}} returned by the sink's <code>write()</code> method (line 40) tells the <code>WritableStream</code> and its writer when to resolve <code>defaultWriter.ready</code>.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Streams','#ws-class','WritableStream')}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.WritableStream")}}</p>
</div>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="https://whatwg-stream-visualizer.glitch.me/">WHATWG Stream Visualiser</a>, for a basic visualisation of readable, writable, and transform streams.</li>
</ul>
